#ifndef DerDList_H
#define DerDList_H


#include "TList.h"

//manage a doubly linked list


class TDerDList : public  TList
{
	
	TListObject 	*last;
	TListObject 	*curr;
	
public:
   	TDerDList();
	
	TDerDList(TListObject *);
	
	void Clear();
	
	~TDerDList();
	
	int IsEmpty(); 

	//set current pointer to the ends of the list

	void Reset();


	// move around the list, leaving the links there

	int Next (TListObject **a);
	int Prev (TListObject **a);

	//manipulate around the list, removing the links

	int GetNext(TListObject **a);
	int GetPrev(TListObject **a);
	
	int Remove(TListObject *a );

	//manipulate around the beginning
	// and end of the list

	void Insert(TListObject *a);
	void Append(TListObject *a);

	// manipulate around the current entry

	void InserThere(TListObject *a);
	void AppendHere(TListObject *a);
	
	//Append a list to the end of this one
	
	void AppendList(TDerDList &rList);
};
#endif